/* Process model C form file: my_sink.pr.c */
/* Portions of this file copyright 1992, 1996 by MIL 3, Inc. */



/* OPNET system definitions */
#include <opnet.h>
#include "/usr/people/jma2/qosip/sink/my_sink.pr.h"
FSM_EXT_DECS
#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		_fstack_local_info.last_line_passed = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	_fstack_local_info.last_line_passed = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	FSM_SYS_STATE
	} my_sink_state;

#define pr_state_ptr            		((my_sink_state*) SimI_Mod_State_Ptr)

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	my_sink_state *op_sv_ptr = pr_state_ptr;




/* Process model interrupt handling procedure */



void
my_sink ()
	{
	int _block_origin = 0;


	FSM_ENTER (my_sink)

	FSM_BLOCK_SWITCH
		{
		/*---------------------------------------------------------*/
		/** state (DISCARD) enter executives **/
		FSM_STATE_ENTER_UNFORCED (0, state0_enter_exec, "DISCARD", "my_sink () [DISCARD enter execs]")
			{
			op_pk_destroy (op_pk_get (op_intrpt_strm ()));
			}


		/** blocking after enter executives of unforced state. **/
		FSM_EXIT (1,my_sink)


		/** state (DISCARD) exit executives **/
		FSM_STATE_EXIT_UNFORCED (0, state0_exit_exec, "DISCARD", "my_sink () [DISCARD exit execs]")
			{
			}


		/** state (DISCARD) transition processing **/
		FSM_TRANSIT_FORCE (0, state0_enter_exec, ;)
		/*---------------------------------------------------------*/



		}


	FSM_EXIT (0,my_sink)
	}




void
my_sink_svar (prs_ptr,var_name,var_p_ptr)
	my_sink_state		*prs_ptr;
	char			*var_name, **var_p_ptr;
	{

	FIN (my_sink_svar (prs_ptr))

	*var_p_ptr = VOS_NIL;

	FOUT;
	}




void
my_sink_diag ()
	{
	int _block_origin;

	FIN (my_sink_diag ())

	BINIT

	FOUT;
	}




void
my_sink_terminate ()
	{
	int _block_origin;

	FIN (my_sink_terminate ())

	BINIT

	FOUT;
	}



Compcode
my_sink_init (pr_state_pptr)
	my_sink_state			**pr_state_pptr;
	{
	int _block_origin = 0;
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	extern int				Vos_Nop ();

	FIN (my_sink_init (pr_state_pptr))

	if (obtype == OPC_NIL)
		{
		if (Vos_Catmem_Register ("proc state vars (my_sink)",
			sizeof (my_sink_state), Vos_Nop, &obtype) == VOSC_FAILURE)
			FRET (OPC_COMPCODE_FAILURE)
		}

	if ((*pr_state_pptr = (my_sink_state*) Vos_Catmem_Alloc (obtype, 1)) == OPC_NIL)
		FRET (OPC_COMPCODE_FAILURE)
	else
		{
		(*pr_state_pptr)->current_block = 0;
		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



enum { _block_origin = __LINE__ };
